OGRE: Ogre::SceneManager::Listener Class Reference

| OGRE 2.2.4 Object-Oriented Graphics Rendering Engine

Public Member Functions | List of all members
Ogre::SceneManager::Listener Class Reference

Class that allows listening in on the various stages of SceneManager processing, so that custom behaviour can be implemented from outside. More...

`#include <OgreSceneManager.h>`

Inheritance diagram for Ogre::SceneManager::Listener:
[legend]

## Public Member Functions
| Listener ()
virtual | ~Listener ()
virtual void | postFindVisibleObjects (SceneManager *source, IlluminationRenderStage irs, Viewport *v)
| Called after searching for visible objects in this SceneManager. More...
virtual void | preFindVisibleObjects (SceneManager *source, IlluminationRenderStage irs, Viewport *v)
| Called prior to searching for visible objects in this SceneManager. More...
virtual void | sceneManagerDestroyed (SceneManager *source)
| Event notifying the listener of the SceneManager's destruction. More...
virtual void | shadowTextureCasterPreViewProj (const Light *light, Camera *camera, size_t iteration)
| This event occurs just before the view & projection matrices are set for rendering into a shadow texture. More...
virtual void | shadowTexturesUpdated (size_t numberOfShadowTextures)
| Event raised after all shadow textures have been rendered into for all queues / targets but before any other geometry has been rendered (including main scene geometry). More...
virtual bool | sortLightsAffectingFrustum (LightList &lightList)
| Hook to allow the listener to override the ordering of lights for the entire frustum. More...

## Detailed Description

Class that allows listening in on the various stages of SceneManager processing, so that custom behaviour can be implemented from outside.

## Constructor & Destructor Documentation

## ◆ Listener()

Ogre::SceneManager::Listener::Listener | ( | void |  | ) |
| inline

## ◆ ~Listener()

virtual Ogre::SceneManager::Listener::~Listener | ( |  | ) |
| inlinevirtual

## Member Function Documentation

## ◆ postFindVisibleObjects()

virtual void Ogre::SceneManager::Listener::postFindVisibleObjects | ( | SceneManager * | source,
|  | IlluminationRenderStage | irs,
|  | Viewport * | v
| ) |  |
| inlinevirtual

Called after searching for visible objects in this SceneManager.

Remarks
  Note that the render queue at this stage will be full of the current scenes contents, ready for rendering. You may manually add renderables to this queue if you wish.

Parameters

  source | The SceneManager instance raising this event.
  irs | The stage of illumination being dealt with. IRS_NONE for a regular render, IRS_RENDER_TO_TEXTURE for a shadow caster render.
  v | The viewport being updated. You can get the camera from here.

## ◆ preFindVisibleObjects()

virtual void Ogre::SceneManager::Listener::preFindVisibleObjects | ( | SceneManager * | source,
|  | IlluminationRenderStage | irs,
|  | Viewport * | v
| ) |  |
| inlinevirtual

Called prior to searching for visible objects in this SceneManager.

Remarks
  Note that the render queue at this stage will be full of the last render's contents and will be cleared after this method is called.

Parameters

  source | The SceneManager instance raising this event.
  irs | The stage of illumination being dealt with. IRS_NONE for a regular render, IRS_RENDER_TO_TEXTURE for a shadow caster render.
  v | The viewport being updated. You can get the camera from here.

Reimplemented in Ogre::Terrain.

## ◆ sceneManagerDestroyed()

virtual void Ogre::SceneManager::Listener::sceneManagerDestroyed | ( | SceneManager * | source | ) |
| inlinevirtual

Event notifying the listener of the SceneManager's destruction.

Reimplemented in Ogre::Terrain.

## ◆ shadowTextureCasterPreViewProj()

virtual void Ogre::SceneManager::Listener::shadowTextureCasterPreViewProj | ( | const Light * | light,
|  | Camera * | camera,
|  | size_t | iteration
| ) |  |
| inlinevirtual

This event occurs just before the view & projection matrices are set for rendering into a shadow texture.

Remarks
  You can use this event hook to perform some custom processing, such as altering the camera being used for rendering the light's view, including setting custom view & projection matrices if you want to perform an advanced shadow technique.

Note
  This event will only be fired when texture shadows are in use.

Parameters

  light | Pointer to the light for which shadows are being rendered
  camera | Pointer to the camera being used to render
  iteration | For lights that use multiple shadow textures, the iteration number

## ◆ shadowTexturesUpdated()

virtual void Ogre::SceneManager::Listener::shadowTexturesUpdated | ( | size_t | numberOfShadowTextures | ) |
| inlinevirtual

Event raised after all shadow textures have been rendered into for all queues / targets but before any other geometry has been rendered (including main scene geometry).

Remarks
  This callback is useful for those that wish to perform some additional processing on shadow textures before they are used to render shadows. For example you could perform some filtering by rendering the existing shadow textures into another alternative shadow texture with a shader.]

Note
  This event will only be fired when texture shadows are in use.

Parameters

  numberOfShadowTextures | The number of shadow textures in use

## ◆ sortLightsAffectingFrustum()

virtual bool Ogre::SceneManager::Listener::sortLightsAffectingFrustum | ( | LightList & | lightList | ) |
| inlinevirtual

Hook to allow the listener to override the ordering of lights for the entire frustum.

Remarks
  Whilst ordinarily lights are sorted per rendered object (

See also
  MovableObject::queryLights), texture shadows adds another issue in that, given there is a finite number of shadow textures, we must choose which lights to render texture shadows from based on the entire frustum. These lights should always be listed first in every objects own list, followed by any other lights which will not cast texture shadows (either because they have shadow casting off, or there aren't enough shadow textures to service them).

  This hook allows you to override the detailed ordering of the lights per frustum. The default ordering is shadow casters first (which you must also respect if you override this method), and ordered by distance from the camera within those 2 groups. Obviously the closest lights with shadow casting enabled will be listed first. Only lights within the range of the frustum will be in the list.

Parameters

  lightList | The list of lights within range of the frustum which you may sort.

Returns
  true if you sorted the list, false otherwise.

The documentation for this class was generated from the following file:

- OgreSceneManager.h